Program Plasma;
-----------------------------------------------------------------
-- Hi! K!O speaks again. Now you get "realtime" plasma effect. --
-- (It means that I don't change palette, I change every pixel --
-- in each frame!).                                            --
-- Simple but very nice in my opinion.                         --
-- It should be in pure assembler for speed, but Pascal version--
-- is far better for learning...                               --
-- Special thanks must go to mnemonic for some ideas of plasma --
-- shape and of course TMT authors for best Pascal compiler    --
-- ever!                                                       --
-----------------------------------------------------------------
-- Remember:                                                   --
-- by changing equation you can get different shapes of plasma --
-----------------------------------------------------------------
var
    cosT, sinT : array[ 0..255 ] of integer;
        VirBuf : array[ 0..63999 ] of byte;
        paleta : array[ 1..768 ] of byte;
        VirScr : dword;
    x, y, i, j : integer;

procedure SetMode( mode : word ); assembler;
asm
  mov  AX, [mode]
  int  $10
end;

procedure FlipScreen( adres : dword ); assembler;
asm
    mov  ESI, [adres]
    mov  EDI, $A0000
    mov  ECX, 16000
    rep  movsd
end;

procedure SetPal; assembler;
asm
  xor  AL, AL
  mov  DX, $3C8
  out  DX, AL
  mov  ESI, offset paleta
  mov  CX, 768
  mov  DX, $3C9
  rep  outsb
end;

procedure MakePalette;
var i : byte;
begin
  FillChar( paleta, 768, 0 );
  for i:=0 to 127 do
    begin
      paleta[ 3*i+1 ]:=i SHR 1;
      paleta[ 3*i+2 ]:=i SHR 2;
      paleta[ 3*i+3 ]:=i SHR 4;
      paleta[ 3*( i+128 )+1 ]:=( 127-i ) SHR 1;
      paleta[ 3*( i+128 )+2 ]:=( 127-i ) SHR 3;
      paleta[ 3*( i+128 )+3 ]:=( 127-i ) SHR 4;
    end
end;

BEGIN
  VirScr:=Ofs( VirBuf );
  for x:=0 to 255 do
    begin
      sinT[ x ]:=round( 255*sin( 2*x*pi/255 ));
      cosT[ x ]:=round( 128*cos( 2*x*pi/255 ));
    end;
  MakePalette;
  SetMode( $0013 );
  SetPal;
  i:=0; j:=0;
  repeat
    for x:=0 to 319 do
      for y:=0 to 199 do    -- Equation for "realtime" plasma is below!
        VirBuf[ x+y*320 ]:=2*x+( cosT[ ( cosT[ ( x+i ) AND $FF ] +
                                 sinT[ ( y+j ) AND $FF ] ) AND $FF ] );
    FlipScreen( VirScr );
    i:=i-4;
    j:=j+2;
  until port[ $60 ] = 1;   -- Esc pressed
  SetMode( $0003 );
END.